/* -*-  Mode: C++; c-file-style: "gnu"; indent-tabs-mode:nil; -*- */
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License version 2 as
// published by the Free Software Foundation;
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//
// Author: Baltzis Petros<mpaltzis@ceid.upatras.gr>

#ifndef LEAKY_BUCKET_HELPER_H
#define LEAKY_BUCKET_HELPER_H

#include "ns3/object-factory.h"
#include "ns3/address.h"
#include "ns3/attribute.h"
#include "ns3/node.h"

namespace ns3 {


/**
 * \Enas heper gia na katastei eukolotero na dhmiourgithei leaky buckets
 * se ena sunolo kombwn
 */
class LeakyBucketHelper
{
public:
 
  LeakyBucketHelper ();

  /**
   * O helper xrhsimopoieitai gia na thesoume ena sunolo apo idioithtes 
   *  gia kapoio leaky
   */
  void SetAttribute (std::string name, const AttributeValue &value);

  void Install (Ptr<NetDevice> ShapedDevice) const;
 
private:
  ObjectFactory m_factory;
  
};

} // namespace ns3

#endif /* ON_OFF_HELPER_H */

